---
title: Firefox 42 for developers
slug: Mozilla/Firefox/Releases/42
tags:
  - '42'
  - Firefox
  - Mozilla
  - Release
  - Release Notes
---
<div>{{FirefoxSidebar}}</div>

<div class="column-container zone-callout"><a href="https://www.mozilla.org/firefox/developer/" style="float: right; margin-bottom: 20px; padding: 10px; text-align: center; border-radius: 4px; display: inline-block; background-color: #81BC2E; white-space: nowrap; color: white; text-shadow: 0px 1px 0px rgba(0, 0, 0, 0.25); box-shadow: 0px 1px 0px 0px rgba(0, 0, 0, 0.2), 0px -1px 0px 0px rgba(0, 0, 0, 0.3) inset;">To test the latest developer features of Firefox,<br>
install Firefox Developer Edition</a> Firefox 42 was released on November 3, 2015. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</div>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<p>Highlights:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Remote_Debugging/Debugging_Firefox_for_Android_over_Wifi">Debugging Firefox for Android over Wifi</a></li>
 <li><a href="/en-US/docs/Tools/WebIDE/Setting_up_runtimes#Configuring_Simulators">Firefox OS Simulator configuration in WebIDE</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Edit_CSS_filters#Saving_filter_presets">CSS filter presets</a></li>
</ul>

<p><a class="external external-icon" href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;classification=Client%20Software&amp;chfieldto=2015-08-10&amp;query_format=advanced&amp;chfield=resolution&amp;chfieldfrom=2015-06-29&amp;chfieldvalue=FIXED&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;component=Developer%20Tools&amp;component=Developer%20Tools%3A%203D%20View&amp;component=Developer%20Tools%3A%20Canvas%20Debugger&amp;component=Developer%20Tools%3A%20Console&amp;component=Developer%20Tools%3A%20Debugger&amp;component=Developer%20Tools%3A%20Framework&amp;component=Developer%20Tools%3A%20Graphic%20Commandline%20and%20Toolbar&amp;component=Developer%20Tools%3A%20Inspector&amp;component=Developer%20Tools%3A%20Memory&amp;component=Developer%20Tools%3A%20Netmonitor&amp;component=Developer%20Tools%3A%20Object%20Inspector&amp;component=Developer%20Tools%3A%20Performance%20Tools%20%28Profiler%2FTimeline%29&amp;component=Developer%20Tools%3A%20Responsive%20Mode&amp;component=Developer%20Tools%3A%20Scratchpad&amp;component=Developer%20Tools%3A%20Source%20Editor&amp;component=Developer%20Tools%3A%20Storage%20Inspector&amp;component=Developer%20Tools%3A%20Style%20Editor&amp;component=Developer%20Tools%3A%20User%20Stories&amp;component=Developer%20Tools%3A%20Web%20Audio%20Editor&amp;component=Developer%20Tools%3A%20WebGL%20Shader%20Editor&amp;component=Developer%20Tools%3A%20WebIDE&amp;product=Firefox&amp;list_id=12478437">All devtools bugs fixed between Firefox 41 and Firefox 42</a>.</p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Vertical {{cssxref('writing-mode')}} is now supported with rtl scripts ({{bug(1131451)}}).</li>
 <li>The values of {{cssxref("caption-side")}} are now relative to the table, and changing actual meaning according to its {{cssxref("writing-mode")}} value {{bug(1202993)}}.</li>
 <li>Non-standard properties like {{cssxref('-moz-margin-start')}} are now aliases of their standard counterpart ({{cssxref('margin-inline-start')}}, …). Previously, it was the opposite. This affects the value returned by {{domxref('CSSStyleDeclaration.cssText')}} and iteration of the properties in a style ruleand iteration of the properties in a style rule, that both use the canonical form ({{bug(1118103)}}).</li>
 <li>The prefixed version of CSS gradients can be turned off by setting the <code>layout.css.prefixes.gradients</code> preference to <code>false</code>.</li>
 <li>Several old bugs with {{cssxref("float")}} and margin collapsing behavior have been fixed ({{bug(478834)}}, {{bug(538194)}}, and {{bug(451791)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Experimental support for the {{htmlattrxref("referrer", "input")}} attribute of the {{HTMLElement("img")}} ({{bug(1166910)}}), {{htmlElement("iframe")}} ({{bug(1175736)}}), {{HTMLElement("a")}} and {{HTMLElement("area")}} ({{bug(1174913)}}) has been added. There is no effect by default, the <code>network.http.enablePerElementReferrer</code> being <code>false</code> by default.</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The {{jsxref("Reflect")}} object has been implemented ({{bug(987514)}}).</li>
 <li>The implementation of the {{jsxref("Proxy")}} {{jsxref("Global_Objects/Proxy/handler/ownKeys", "handler.ownKeys()")}} trap has been updated to match the final ES2015 specification ({{bug(1049662)}}).</li>
 <li>Calling {{jsxref("Map")}}, {{jsxref("Set")}}, or {{jsxref("WeakMap")}} without {{jsxref('Operators', 'new')}}, will now throw a {{jsxref("TypeError")}} ({{bug(1083752)}}).</li>
</ul>

<h3 id="InterfacesAPIsDOM">Interfaces/APIs/DOM</h3>

<h4 id="DOM_HTML_DOM">DOM &amp; HTML DOM</h4>

<ul>
 <li>Images with an {{HTMLattrxref('id', 'img')}} are no more listed as property of the {{domxref("Window")}} interface: <code>&lt;img id="login"&gt;</code> isn't accessible as <code>window.login</code> anymore. This behavior was introduced in Firefox 26 and has been removed to match a later change in the spec. ({{bug(959992)}})</li>
 <li>{{domxref('MouseEvent.offsetX')}} and {{domxref('MouseEvent.offsetY')}} have been added ({{bug(69787)}}).</li>
 <li>The {{domxref("HTMLInputElement")}} interface has been experimentally extended to handle the upload of directories ({{bug(1164310)}}). These four members can be exposed by setting the <code>dom.input.dirpicker</code> preference to <code>true</code>:
  <ul>
   <li>{{domxref("HTMLInputElement.directory")}}</li>
   <li>{{domxref("HTMLInputElement.isFilesAndDirectoriesSupported")}}</li>
   <li>{{domxref("HTMLInputElement.getFilesAndDirectories()")}}</li>
   <li>{{domxref("HTMLInputElement.chooseDirectory()")}}</li>
  </ul>
 </li>
 <li>The {{domxref("Directory")}} interface has been experimentally extended ({{bug(1177688)}}). The two members {{domxref("Directory.path")}} and {{domxref("Directory.getContents")}} can be exposed by setting the <code>dom.input.dirpicker</code> preference to <code>true</code>.</li>
 <li>The <code>HTMLMediaElement.mozSrcObject</code> has been renamed in {{domxref('HTMLMediaElement.srcObject')}} ({{bug(1175523)}}).</li>
</ul>

<h4 id="Service_Workers">Service Workers</h4>

<ul>
 <li>{{domxref('Request.context')}} has been removed ({{bug(1188062)}}).</li>
 <li>The <a href="/en-US/docs/Web/API/Push_API">Push API</a> has been activated by default on Firefox for Desktop ({{bug(1153499)}}), but only on the Nightly/Dev Edition/Beta channels. It is being deactivated by default in the Release channel until consumer UX and debugging features have been properly implemented ({{bug(1207875)}}.) You can still activate it by enabling the <span id="summary_alias_container"><span id="short_desc_nonedit_display"><code>dom.push.enabled</code> pref in <a>about:config</a>.</span></span></li>
 <li>The {{domxref("PushManager.hasPermission()")}} method has been deprecated in the spec, and replaced with the {{domxref("PushManager.permissionState()")}} method. Firefox has updated its implementation to reflect this ({{bug("1183853")}}.)</li>
 <li>Service-worker-related additions to the <a href="/en-US/docs/Web/API/Notifications_API">Notifications API</a> have been implemented ({{bug(1114554)}}), but are disabled in this release.</li>
</ul>

<h4 id="Web_Animations_API">Web Animations API</h4>

<p>Our experimental implementation of <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a> have been extended to support:</p>

<ul>
 <li>The {{domxref('AnimationPlayer.playbackRate')}} property ({{bug(1127380)}}).</li>
 <li>The {{domxref('CSSAnimation')}} and {{domxref('CSSTransition')}} interfaces ({{bug(1178186)}}).</li>
 <li>The {{domxref('Animation.reverse()')}} method ({{bug(1150808)}}).</li>
 <li>The {{domxref('AnimationPlaybackEvent')}} interface has been added and {{event('cancel')}} and {{event('finish')}} are now fired on {{domxref('Animation')}} ({{bug(1178664)}}).</li>
</ul>

<h4 id="Web_Components">Web Components</h4>

<p>Our experimental implementation of the <a href="/en-US/docs/Web/Web_Components/Shadow_DOM">Shadow DOM</a> has been modified:</p>

<ul>
 <li>When trying to invoke {{domxref('Node.cloneNode()')}} on a {{domxref('ShadowRoot')}}, throws a <code>DataCloneError</code> exception ({{bug(1176757)}}).</li>
 <li>When invoking {{domxref('Document.importNode()')}} with a {{domxref('ShadowRoot')}} as an argument, we now throws a <code>NotSupportedError</code> exception ({{bug(1177914)}}).</li>
 <li>When invoking {{domxref('Document.adoptNode()')}} with a {{domxref('ShadowRoot')}} as an argument, we now throws a <code>HierarchyRequestError</code> exception ({{bug(1177991)}}).</li>
</ul>

<h4 id="WebGL">WebGL</h4>

<ul>
 <li>WebGL2 {{domxref('WebGLTransformFeedback')}} has been implemented ({{bug(1048724)}}).</li>
 <li>To obtain a WebGL2 context, {{domxref('HTMLCanvasElement.getContext()')}} now takes <code>webgl2</code> instead of <code>experimental-webgl2</code> ({{bug(1187174)}}).</li>
</ul>

<h4 id="WebRTC">WebRTC</h4>

<ul>
 <li>The {{domxref("RTCPeerConnection.createOffer()")}}'s options data type, {{domxref("RTCOfferOptions")}}, has been updated to more closely match the specification. Among other changes, it is now based upon the {{domxref("RTCOfferAnswerOptions")}} dictionary, which provides the {{domxref("RTCOfferAnswerOptions.voiceActivityDetection", "voiceActivityDetection")}} option.</li>
 <li>The {{domxref("RTCAnswerOptions")}} dictionary has been added. This is the type used for the <code>options</code> parameter to {{DOMxRef("RTCPeerConnection.createAnswer", "createAnswer()")}}.</li>
 <li>The <code>RTCICECandidatePairStats.mozPriority</code> has been renamed to {{domxref('RTCICECandidatePairStats.priority')}} ({{bug(1184426)}}).</li>
</ul>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>The {{domxref("ImageBitmap")}} interface and the {{domxref("ImageBitmapFactories.createImageBitmap","createImageBitmap()")}} method have been implemented. They are available on regular window scripts and in Web workers and allow efficient posting of images between window and worker contexts ({{bug(1044102)}}).</li>
</ul>

<h4 id="Miscellaneous">Miscellaneous</h4>

<ul>
 <li>The {{domxref('IDBCursorWithValue')}} interface is now available in <a href="/en-US/docs/Web/API/Web_Workers_API">Web workers</a> ({{bug(1188115)}}).</li>
 <li>Error events sent in <a href="/en-US/docs/Web/API/Web_Workers_API">Web workers</a> doesn't bubble anymore ({{bug(1188141)}}).</li>
 <li><a href="/en-US/docs/Web/API/Media_Source_Extensions_API">Media Source Extensions</a> (MSE) has been activated for all Web sites, and no more for a white list of sites ({{bug(1185611)}}).</li>
 <li>The non-standard and deprecated {{domxref('Window.mozRequestAnimationFrame()')}} has been removed ({{bug(909154)}}). Use the standard {{domxref('Window.requestAnimationFrame()')}} instead.</li>
 <li>Speech synthesis (text-to-speech) has been implemented in Firefox Desktop for Windows, hidden behind the <code>media.webspeech.synth.enabled</code> flag in <code>about:config</code> ({{bug("1003457")}}.) See <a href="/en-US/docs/Web/API/Web_Speech_API">Web Speech API</a> for more information.</li>
</ul>

<h3 id="MathML">MathML</h3>

<p><em>No change.</em></p>

<h3 id="SVG">SVG</h3>

<p><em>No change.</em></p>

<h3 id="AudioVideo">Audio/Video</h3>

<p><em>No change.</em></p>

<h2 id="HTTP">HTTP</h2>

<ul>
 <li>Firefox 41 and earlier versions were incorrectly accepting undefined or invalid pseudo-header fields in HTTP/2 responses. This is now fixed and the only pseudo-header field accepted from Firefox 42 is the <em>:status</em> as per the specification. Response headers containing arbitrary fields are considered malformed. ({{bug(1136727)}})</li>
</ul>

<h2 id="Networking">Networking</h2>

<ul>
 <li>The CSP <code><a href="/Web/Security/CSP/CSP_policy_directives#upgrade-insecure-requests">upgrade-insecure-requests</a></code> directive has been implemented ({{bug(1139297)}}).</li>
</ul>

<h2 id="Security">Security</h2>

<ul>
 <li>EV certificates with a validity greater than 39 months are now considered and handled as DV certificates ({{bug(1145679)}}).</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="Interfaces">Interfaces</h3>

<h4 id="nsIContentPolicy">nsIContentPolicy</h4>

<ul>
 <li>The <code><strong>TYPE_EMBED</strong></code> constant has been added to <code><a href="/en-US/docs/Mozilla/Tech/XPCOM/Reference/Interface/nsIContentPolicy">nsIContentPolicy</a></code> to allow Gecko internals and add-on code to better differentiate different types of requests. Previously, <code><strong>TYPE_OBJECT</strong></code> was used for these cases ({{bug(1148030)}}).</li>
 <li>Similarly, the <strong><code>TYPE_SUBDOCUMENT</code></strong> constants has been split into <code><strong>TYPE_FRAME</strong></code> and <strong><code>TYPE_IFRAME</code></strong> ({{bug(1148044)}}).</li>
</ul>

<h3 id="XUL">XUL</h3>

<p><em>No change.</em></p>

<h3 id="JavaScript_code_modules">JavaScript code modules</h3>

<p><em>No change.</em></p>

<h3 id="XPCOM">XPCOM</h3>

<p><em>No change.</em></p>

<h3 id="Other">Other</h3>

<p><em>No change.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/42/">Site Compatibility for Firefox 42</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers('41')}}</p>
